{Na rozdiel od Real modu neukladam pamat v oblasti HEAPu, ale v EMS !!!}

unit EMS_DRV;

{$N-,E-,F-,B-,G+,A+,R-,S-,I-,X-,V-,C-,O-,Y-,T-,D+,L+}

interface
{$IFDEF WINDOWS}
Uses WinDos,Crt;
{$ELSE}
Uses Dos,Crt;
{$ENDIF}

const MaxPages    = 250;              (*1000d*$8000 je 32MB*)
      Segment     = 32768;              (*Velkost jedneho segmentu je 8000h=32768d Byte*)

type  Page  = array [0..Segment-1] of byte;
      Pages = array [0..MaxPages-1] of ^Page;

const MaxEMSAvail =  MaxPages*Segment; (*Maximalne mnozstvo pamati EMS k alokacii !!!*)

var   Old_Int_08h   : procedure;
      Stranka       : Pages;
      Counter       : word;

procedure Beep;
procedure Test;
procedure Alokuj_Pamat;
procedure Uvolni_Pamat;
procedure Vyplni_Pamat(Cislo:byte);
procedure Zapis_Do_Pamati(Page,Index:word; Num:byte);
procedure Blok_Do_Pamati(Page,Index,Koniec:word; Num:byte);
procedure Citaj_Blok_Z_Portu(Stranka: pointer; Port, Size:word);
function Citaj_Z_Pamati(Page,Index:word):byte;
procedure Zapis_Do_Pamati_Linearne(Adresa:longint; Num:byte);
function Citaj_Z_Pamati_Linearne(Adresa:longint):byte;

implementation

{$F+}

procedure New_Int_08h; interrupt;
begin
     asm
        pushf
     end;
     Inc(Counter);
     Old_Int_08h;
end;

{$F-}

procedure Beep;
begin
     Sound(1000);
     Delay(100);
     NoSound;
end;

procedure Alokuj_Pamat;
var   i   : word;
begin
     WriteLn('*******************************************************************************');
     WriteLn('EMS memory driver with support linear adressing by Ing. Eduard Jadron, SLOVAKIA');
     WriteLn('*******************************************************************************');
     Delay(1000);
     for i:=0 to MaxPages do
         begin
              GetMem(Stranka[i],SizeOf(Page));          (*Alokujem pamat EMS ...*)
         end;
end;

procedure Uvolni_Pamat;
var   i   : word;
begin
     for i:=0 to MaxPages do
         begin
              FreeMem(Stranka[i],SizeOf(Page));         {Uvolnim pamat v EMS ...}
         end;
end;

procedure Vyplni_Pamat(Cislo:byte);
var   i   : word;
begin
     for i:=0 to MaxPages do
         begin
              FillChar(Stranka[i]^,SizeOf(Page),Cislo);   (*Vyplnim pamat cislom ...*)
         end;
end;

procedure Zapis_Do_Pamati(Page,Index:word; Num:byte);
begin
     Stranka[Page]^[Index]:=Num;
end;

function Citaj_Z_Pamati(Page,Index:word):byte;
begin
     Citaj_Z_Pamati:=Stranka[Page]^[Index];
end;

procedure Blok_Do_Pamati(Page,Index,Koniec:word; Num:byte);
begin
     FillChar(Stranka[Page]^[Index],(Koniec-Index)+1,Num);
end;

procedure Citaj_Blok_Z_Portu(Stranka: pointer; Port, Size:word);
var Seg_Adr, Ofs_Adr : word;
begin
     Seg_Adr:=MemW[Seg(Stranka):Ofs(Stranka)+$02];
     Ofs_Adr:=MemW[Seg(Stranka):Ofs(Stranka)+$00];
     asm
        pusha
        cld                             {Priznak smeru}
        mov ax,word ptr ss:[Seg_Adr]
        mov es,ax
        mov di,word ptr ss:[Ofs_Adr]
        mov cx,word ptr ss:[Size]
        mov dx,word ptr ss:[Port]
        rep insb                        {Citam z portu urceneho DX na adresu ES:DI, pokial CX <> 0 ! }
        popa
     end;
end;

procedure Zapis_Do_Pamati_Linearne(Adresa:longint; Num:byte);
begin
     Stranka[Adresa div Segment]^[Adresa mod Segment]:=Num;
end;

function Citaj_Z_Pamati_Linearne(Adresa:longint):byte;
begin
     Citaj_Z_Pamati_Linearne:=Stranka[Adresa div Segment]^[Adresa mod Segment];
end;

procedure Test;
var   i   : word;
begin
     GetIntVec($08,@Old_Int_08h);
     SetIntVec($08,@New_Int_08h);
(***********************************************************************************************************)
{     ClrScr;}
     WriteLn('************************************************');
     WriteLn('Alokujem volnu pamat EMS ',((MaxPages*SizeOf(Page)) div 1024) div 1000,'MB, prosim cakaj !!!');
     WriteLn('************************************************');
     Counter:=0;
(***********************************************************************************************************)
     for i:=0 to MaxPages-1 do
         begin
              GetMem(Stranka[i],SizeOf(Page));          (*Alokujem pamat EMS ...*)
         end;
     WriteLn('Alokoval som pamat za ',Counter/18.18:2:3,' sec. !!!');
     Beep;
(***********************************************************************************************************)
     Counter:=0;
     for i:=0 to MaxPages-1 do
         begin
              FillChar(Stranka[i]^,SizeOf(Page),$00);   (*Vyplnim pamat cislom ...*)
         end;
     WriteLn('Vyplnil  som pamat za ',Counter/18.18:2:3,' sec. !!!');
     Beep;
(***********************************************************************************************************)
     Counter:=0;
     for i:=0 to MaxPages-1 do
         begin
              FreeMem(Stranka[i],SizeOf(Page));         {Uvolnim pamat v EMS ...}
         end;
     WriteLn('Uvolnil  som pamat za ',Counter/18.18:2:3,' sec. !!!');
     WriteLn('************************************************');
     Beep;
(***********************************************************************************************************)
     SetIntVec($08,@Old_Int_08h);
end;

end.